{
  description = "Michael's NixOS Homelab Flake";

  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
    disko = {
      url = "github:nix-community/disko";
      inputs.nixpkgs.follows = "nixpkgs";
    };
  };

  outputs = inputs @ {
    nixpkgs,
    disko,
    ...
  }: let
    nodes = [
      "patrick"
      "spongebob"
    ];
  in {
    nixosConfigurations = builtins.listToAttrs (map (name: {
        name = name;
        value = nixpkgs.lib.nixosSystem {
          specialArgs = {
            meta = {hostname = name;};
          };
          system = "x86_64-linux";
          modules = [
            disko.nixosModules.disko
            ./hardware-configuration.nix
            ./configuration.nix
            ./disk-config.nix
          ];
        };
      })
      nodes);
  };
}
